import{S as Jf,i as Zf,s as ec,e as s,k as p,w as u,t as r,M as tc,c as n,d as a,m as f,a as o,x as m,h as i,b as h,G as t,g as c,y as d,q as _,o as v,B as y,v as ac}from"../../chunks/vendor-hf-doc-builder.js";import{T as sc}from"../../chunks/Tip-hf-doc-builder.js";import{I as A}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as T}from"../../chunks/CodeBlock-hf-doc-builder.js";function nc(As){let g;return{c(){g=r(`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},l(P){g=i(P,`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},m(P,D){c(P,g,D)},d(P){P&&a(g)}}}function oc(As){let g,P,D,le,Qt,Se,Zn,Jt,eo,Ps,k,to,Zt,ao,so,qe,no,oo,lt,ro,io,xs,pt,lo,Ss,pe,ea,U,qs,po,ta,fo,co,aa,ho,uo,w,C,sa,mo,_o,na,vo,yo,oa,wo,bo,F,ra,go,Eo,ia,$o,jo,la,ko,To,R,pa,Do,Ao,fa,Po,xo,ca,So,qo,V,ha,No,Io,ua,Uo,Co,ma,Fo,Ro,G,da,Vo,Go,_a,Mo,zo,va,Ho,Oo,M,ya,Bo,Lo,wa,Xo,Yo,ba,Wo,Ko,z,ga,Qo,Jo,Ea,Zo,er,$a,tr,Ns,ft,ar,Is,H,fe,ja,Ne,sr,ka,nr,Us,Ie,Ue,or,rr,Cs,ce,ir,Ta,lr,pr,Fs,Ce,Rs,O,he,Da,Fe,fr,Aa,cr,Vs,ue,hr,Re,ur,mr,Gs,Ve,Ms,B,me,Pa,Ge,dr,xa,_r,zs,x,vr,Sa,yr,wr,qa,br,gr,Hs,Me,Os,de,Er,Na,$r,jr,Bs,L,_e,Ia,ze,kr,Ua,Tr,Ls,S,Dr,Ca,Ar,Pr,Fa,xr,Sr,Xs,He,Ys,X,ve,Ra,Oe,qr,Va,Nr,Ws,ct,Ir,Ks,ye,Qs,we,Ur,ht,Cr,Fr,Js,Be,Zs,ut,Rr,en,Y,be,Ga,Le,Vr,Ma,Gr,tn,mt,Mr,an,q,zr,dt,Hr,Or,_t,Br,Lr,sn,ge,Xr,vt,Yr,Wr,nn,Xe,on,yt,Kr,rn,W,Ee,za,Ye,Qr,Ha,Jr,ln,wt,Zr,pn,$e,ei,bt,ti,ai,fn,We,cn,gt,si,hn,Et,ni,un,Ke,mn,j,Oa,oi,ri,Ba,ii,li,La,pi,fi,Qe,ci,hi,dn,K,je,Xa,Je,ui,Ya,mi,_n,$t,di,vn,jt,_i,yn,Ze,wn,Q,ke,Wa,et,vi,Ka,yi,bn,Te,wi,Qa,bi,gi,gn,kt,Ei,En,tt,$n,De,$i,Ja,ji,ki,jn,at,kn,J,Ae,Za,st,Ti,es,Di,Tn,N,Ai,nt,Pi,xi,ot,Si,qi,Dn,Tt,Ni,An,Pe,ts,Z,as,Ii,Ui,ss,Ci,Fi,ns,Ri,Vi,b,ee,os,Gi,Mi,rs,zi,Hi,is,Oi,Bi,te,ls,Li,Xi,ps,Yi,Wi,fs,Ki,Qi,ae,cs,Ji,Zi,hs,el,tl,us,al,sl,se,ms,nl,ol,ds,rl,il,_s,ll,pl,ne,vs,fl,cl,ys,hl,ul,ws,ml,dl,oe,bs,_l,vl,gs,yl,wl,Es,bl,gl,re,$s,El,$l,js,jl,kl,ks,Tl,Pn,Dt,Dl,xn,I,Ts,Al,Pl,Ds,xl,Sl,At,Pt,ql,Nl,Sn,rt,qn;return Se=new A({}),Ne=new A({}),Ce=new T({props:{code:`import torch

torch.backends.cudnn.benchmark = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cudnn.benchmark = <span class="hljs-literal">True</span>`}}),Fe=new A({}),Ve=new T({props:{code:`import torch

torch.backends.cuda.matmul.allow_tf32 = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cuda.matmul.allow_tf32 = <span class="hljs-literal">True</span>`}}),Ge=new A({}),Me=new T({props:{code:`from torch import autocast
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5")
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
with autocast("cuda"):
    image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">from</span> torch <span class="hljs-keyword">import</span> autocast
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
<span class="hljs-keyword">with</span> autocast(<span class="hljs-string">&quot;cuda&quot;</span>):
    image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),ze=new A({}),He=new T({props:{code:`pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
image = pipe(prompt).images[0]`,highlighted:`pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Oe=new A({}),ye=new sc({props:{$$slots:{default:[nc]},$$scope:{ctx:As}}}),Be=new T({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_attention_slicing()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_attention_slicing()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Le=new A({}),Xe=new T({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_vae_slicing()
images = pipe([prompt] * 32).images`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_vae_slicing()
images = pipe([prompt] * <span class="hljs-number">32</span>).images`}}),Ye=new A({}),We=new T({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Ke=new T({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Je=new A({}),Ze=new T({props:{code:`print(pipe.unet.conv_out.state_dict()["weight"].stride())  # (2880, 9, 3, 1)
pipe.unet.to(memory_format=torch.channels_last)  # in-place operation
print(
    pipe.unet.conv_out.state_dict()["weight"].stride()
)  # (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works`,highlighted:`<span class="hljs-built_in">print</span>(pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride())  <span class="hljs-comment"># (2880, 9, 3, 1)</span>
pipe.unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># in-place operation</span>
<span class="hljs-built_in">print</span>(
    pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride()
)  <span class="hljs-comment"># (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works</span>`}}),et=new A({}),tt=new T({props:{code:`import time
import torch
from diffusers import StableDiffusionPipeline
import functools

# torch disable grad
torch.set_grad_enabled(False)

# set variables
n_experiments = 2
unet_runs_per_experiment = 50

# load inputs
def generate_inputs():
    sample = torch.randn(2, 4, 64, 64).half().cuda()
    timestep = torch.rand(1).half().cuda() * 999
    encoder_hidden_states = torch.randn(2, 77, 768).half().cuda()
    return sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")
unet = pipe.unet
unet.eval()
unet.to(memory_format=torch.channels_last)  # use channels_last memory format
unet.forward = functools.partial(unet.forward, return_dict=False)  # set return_dict=False as default

# warmup
for _ in range(3):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

# trace
print("tracing..")
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.eval()
print("done tracing")


# warmup and optimize graph
for _ in range(5):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


# benchmarking
with torch.inference_mode():
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        print(f"unet traced inference took {time.time() - start_time:.2f} seconds")
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        print(f"unet inference took {time.time() - start_time:.2f} seconds")

# save the model
unet_traced.save("unet_traced.pt")`,highlighted:`<span class="hljs-keyword">import</span> time
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> functools

<span class="hljs-comment"># torch disable grad</span>
torch.set_grad_enabled(<span class="hljs-literal">False</span>)

<span class="hljs-comment"># set variables</span>
n_experiments = <span class="hljs-number">2</span>
unet_runs_per_experiment = <span class="hljs-number">50</span>

<span class="hljs-comment"># load inputs</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_inputs</span>():
    sample = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">4</span>, <span class="hljs-number">64</span>, <span class="hljs-number">64</span>).half().cuda()
    timestep = torch.rand(<span class="hljs-number">1</span>).half().cuda() * <span class="hljs-number">999</span>
    encoder_hidden_states = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">77</span>, <span class="hljs-number">768</span>).half().cuda()
    <span class="hljs-keyword">return</span> sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)
unet = pipe.unet
unet.<span class="hljs-built_in">eval</span>()
unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># use channels_last memory format</span>
unet.forward = functools.partial(unet.forward, return_dict=<span class="hljs-literal">False</span>)  <span class="hljs-comment"># set return_dict=False as default</span>

<span class="hljs-comment"># warmup</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">3</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

<span class="hljs-comment"># trace</span>
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;tracing..&quot;</span>)
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.<span class="hljs-built_in">eval</span>()
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;done tracing&quot;</span>)


<span class="hljs-comment"># warmup and optimize graph</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">5</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


<span class="hljs-comment"># benchmarking</span>
<span class="hljs-keyword">with</span> torch.inference_mode():
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet traced inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)

<span class="hljs-comment"># save the model</span>
unet_traced.save(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)`}}),at=new T({props:{code:`from diffusers import StableDiffusionPipeline
import torch
from dataclasses import dataclass


@dataclass
class UNet2DConditionOutput:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

# use jitted unet
unet_traced = torch.jit.load("unet_traced.pt")
# del pipe.unet
class TracedUNet(torch.nn.Module):
    def __init__(self):
        super().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    def forward(self, latent_model_input, t, encoder_hidden_states):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[0]
        return UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

with torch.inference_mode():
    image = pipe([prompt] * 1, num_inference_steps=50).images[0]`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> dataclasses <span class="hljs-keyword">import</span> dataclass


<span class="hljs-meta">@dataclass</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">UNet2DConditionOutput</span>:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># use jitted unet</span>
unet_traced = torch.jit.load(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)
<span class="hljs-comment"># del pipe.unet</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">TracedUNet</span>(torch.nn.Module):
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self</span>):
        <span class="hljs-built_in">super</span>().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">forward</span>(<span class="hljs-params">self, latent_model_input, t, encoder_hidden_states</span>):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[<span class="hljs-number">0</span>]
        <span class="hljs-keyword">return</span> UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

<span class="hljs-keyword">with</span> torch.inference_mode():
    image = pipe([prompt] * <span class="hljs-number">1</span>, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]`}}),st=new A({}),rt=new T({props:{code:`from diffusers import StableDiffusionPipeline
import torch

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

pipe.enable_xformers_memory_efficient_attention()

with torch.inference_mode():
    sample = pipe("a small cat")

# optional: You can disable it via
# pipe.disable_xformers_memory_efficient_attention()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-keyword">with</span> torch.inference_mode():
    sample = pipe(<span class="hljs-string">&quot;a small cat&quot;</span>)

<span class="hljs-comment"># optional: You can disable it via</span>
<span class="hljs-comment"># pipe.disable_xformers_memory_efficient_attention()</span>`}}),{c(){g=s("meta"),P=p(),D=s("h1"),le=s("a"),Qt=s("span"),u(Se.$$.fragment),Zn=p(),Jt=s("span"),eo=r("Memory and speed"),Ps=p(),k=s("p"),to=r("We present some techniques and ideas to optimize \u{1F917} Diffusers "),Zt=s("em"),ao=r("inference"),so=r(" for memory or speed. As a general rule, we recommend the use of "),qe=s("a"),no=r("xFormers"),oo=r(" for memory efficient attention, please see the recommended "),lt=s("a"),ro=r("installation instructions"),io=r("."),xs=p(),pt=s("p"),lo=r("We\u2019ll discuss how the following settings impact performance and memory."),Ss=p(),pe=s("table"),ea=s("thead"),U=s("tr"),qs=s("th"),po=p(),ta=s("th"),fo=r("Latency"),co=p(),aa=s("th"),ho=r("Speedup"),uo=p(),w=s("tbody"),C=s("tr"),sa=s("td"),mo=r("original"),_o=p(),na=s("td"),vo=r("9.50s"),yo=p(),oa=s("td"),wo=r("x1"),bo=p(),F=s("tr"),ra=s("td"),go=r("cuDNN auto-tuner"),Eo=p(),ia=s("td"),$o=r("9.37s"),jo=p(),la=s("td"),ko=r("x1.01"),To=p(),R=s("tr"),pa=s("td"),Do=r("autocast (fp16)"),Ao=p(),fa=s("td"),Po=r("5.47s"),xo=p(),ca=s("td"),So=r("x1.74"),qo=p(),V=s("tr"),ha=s("td"),No=r("fp16"),Io=p(),ua=s("td"),Uo=r("3.61s"),Co=p(),ma=s("td"),Fo=r("x2.63"),Ro=p(),G=s("tr"),da=s("td"),Vo=r("channels last"),Go=p(),_a=s("td"),Mo=r("3.30s"),zo=p(),va=s("td"),Ho=r("x2.88"),Oo=p(),M=s("tr"),ya=s("td"),Bo=r("traced UNet"),Lo=p(),wa=s("td"),Xo=r("3.21s"),Yo=p(),ba=s("td"),Wo=r("x2.96"),Ko=p(),z=s("tr"),ga=s("td"),Qo=r("memory efficient attention"),Jo=p(),Ea=s("td"),Zo=r("2.63s"),er=p(),$a=s("td"),tr=r("x3.61"),Ns=p(),ft=s("em"),ar=r(`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),Is=p(),H=s("h2"),fe=s("a"),ja=s("span"),u(Ne.$$.fragment),sr=p(),ka=s("span"),nr=r("Enable cuDNN auto-tuner"),Us=p(),Ie=s("p"),Ue=s("a"),or=r("NVIDIA cuDNN"),rr=r("\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),Cs=p(),ce=s("p"),ir=r("Since we\u2019re using "),Ta=s("strong"),lr=r("convolutional networks"),pr=r(" (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),Fs=p(),u(Ce.$$.fragment),Rs=p(),O=s("h3"),he=s("a"),Da=s("span"),u(Fe.$$.fragment),fr=p(),Aa=s("span"),cr=r("Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),Vs=p(),ue=s("p"),hr=r("On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Re=s("a"),ur=r("here"),mr=r(". All you need to do is to add this before your inference:"),Gs=p(),u(Ve.$$.fragment),Ms=p(),B=s("h2"),me=s("a"),Pa=s("span"),u(Ge.$$.fragment),dr=p(),xa=s("span"),_r=r("Automatic mixed precision (AMP)"),zs=p(),x=s("p"),vr=r("If you use a CUDA GPU, you can take advantage of "),Sa=s("code"),yr=r("torch.autocast"),wr=r(" to perform inference roughly twice as fast at the cost of slightly lower precision. All you need to do is put your inference call inside an "),qa=s("code"),br=r("autocast"),gr=r(" context manager. The following example shows how to do it using Stable Diffusion text-to-image generation as an example:"),Hs=p(),u(Me.$$.fragment),Os=p(),de=s("p"),Er=r("Despite the precision loss, in our experience the final image results look the same as the "),Na=s("code"),$r=r("float32"),jr=r(" versions. Feel free to experiment and report back!"),Bs=p(),L=s("h2"),_e=s("a"),Ia=s("span"),u(ze.$$.fragment),kr=p(),Ua=s("span"),Tr=r("Half precision weights"),Ls=p(),S=s("p"),Dr=r("To save more GPU memory and get even more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Ca=s("code"),Ar=r("fp16"),Pr=r(", and telling PyTorch to use the "),Fa=s("code"),xr=r("float16"),Sr=r(" type when loading them:"),Xs=p(),u(He.$$.fragment),Ys=p(),X=s("h2"),ve=s("a"),Ra=s("span"),u(Oe.$$.fragment),qr=p(),Va=s("span"),Nr=r("Sliced attention for additional memory savings"),Ws=p(),ct=s("p"),Ir=r("For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),Ks=p(),u(ye.$$.fragment),Qs=p(),we=s("p"),Ur=r("To perform the attention computation sequentially over each head, you only need to invoke "),ht=s("a"),Cr=r("enable_attention_slicing()"),Fr=r(" in your pipeline before inference, like here:"),Js=p(),u(Be.$$.fragment),Zs=p(),ut=s("p"),Rr=r("There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),en=p(),Y=s("h2"),be=s("a"),Ga=s("span"),u(Le.$$.fragment),Vr=p(),Ma=s("span"),Gr=r("Sliced VAE decode for larger batches"),tn=p(),mt=s("p"),Mr=r("To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),an=p(),q=s("p"),zr=r("You likely want to couple this with "),dt=s("a"),Hr=r("enable_attention_slicing()"),Or=r(" or "),_t=s("a"),Br=r("enable_xformers_memory_efficient_attention()"),Lr=r(" to further minimize memory use."),sn=p(),ge=s("p"),Xr=r("To perform the VAE decode one image at a time, invoke "),vt=s("a"),Yr=r("enable_vae_slicing()"),Wr=r(" in your pipeline before inference. For example:"),nn=p(),u(Xe.$$.fragment),on=p(),yt=s("p"),Kr=r("You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),rn=p(),W=s("h2"),Ee=s("a"),za=s("span"),u(Ye.$$.fragment),Qr=p(),Ha=s("span"),Jr=r("Offloading to CPU with accelerate for memory savings"),ln=p(),wt=s("p"),Zr=r("For additional memory savings, you can offload the weights to CPU and only load them to GPU when performing the forward pass."),pn=p(),$e=s("p"),ei=r("To perform CPU offloading, all you have to do is invoke "),bt=s("a"),ti=r("enable_sequential_cpu_offload()"),ai=r(":"),fn=p(),u(We.$$.fragment),cn=p(),gt=s("p"),si=r("And you can get the memory consumption to < 3GB."),hn=p(),Et=s("p"),ni=r("If is also possible to chain it with attention slicing for minimal memory consumption (< 2GB)."),un=p(),u(Ke.$$.fragment),mn=p(),j=s("p"),Oa=s("strong"),oi=r("Note"),ri=r(": When using "),Ba=s("code"),ii=r("enable_sequential_cpu_offload()"),li=r(", it is important to "),La=s("strong"),pi=r("not"),fi=r(" move the pipeline to CUDA beforehand or else the gain in memory consumption will only be minimal. See "),Qe=s("a"),ci=r("this issue"),hi=r(" for more information."),dn=p(),K=s("h2"),je=s("a"),Xa=s("span"),u(Je.$$.fragment),ui=p(),Ya=s("span"),mi=r("Using Channels Last memory format"),_n=p(),$t=s("p"),di=r("Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),vn=p(),jt=s("p"),_i=r("For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),yn=p(),u(Ze.$$.fragment),wn=p(),Q=s("h2"),ke=s("a"),Wa=s("span"),u(et.$$.fragment),vi=p(),Ka=s("span"),yi=r("Tracing"),bn=p(),Te=s("p"),wi=r("Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),Qa=s("code"),bi=r("ScriptFunction"),gi=r(" is returned that will be optimized using just-in-time compilation."),gn=p(),kt=s("p"),Ei=r("To trace our UNet model, we can use the following:"),En=p(),u(tt.$$.fragment),$n=p(),De=s("p"),$i=r("Then we can replace the "),Ja=s("code"),ji=r("unet"),ki=r(" attribute of the pipeline with the traced model like the following"),jn=p(),u(at.$$.fragment),kn=p(),J=s("h2"),Ae=s("a"),Za=s("span"),u(st.$$.fragment),Ti=p(),es=s("span"),Di=r("Memory Efficient Attention"),Tn=p(),N=s("p"),Ai=r("Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),nt=s("a"),Pi=r("code"),xi=r(", "),ot=s("a"),Si=r("paper"),qi=r("."),Dn=p(),Tt=s("p"),Ni=r("Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),An=p(),Pe=s("table"),ts=s("thead"),Z=s("tr"),as=s("th"),Ii=r("GPU"),Ui=p(),ss=s("th"),Ci=r("Base Attention FP16"),Fi=p(),ns=s("th"),Ri=r("Memory Efficient Attention FP16"),Vi=p(),b=s("tbody"),ee=s("tr"),os=s("td"),Gi=r("NVIDIA Tesla T4"),Mi=p(),rs=s("td"),zi=r("3.5it/s"),Hi=p(),is=s("td"),Oi=r("5.5it/s"),Bi=p(),te=s("tr"),ls=s("td"),Li=r("NVIDIA 3060 RTX"),Xi=p(),ps=s("td"),Yi=r("4.6it/s"),Wi=p(),fs=s("td"),Ki=r("7.8it/s"),Qi=p(),ae=s("tr"),cs=s("td"),Ji=r("NVIDIA A10G"),Zi=p(),hs=s("td"),el=r("8.88it/s"),tl=p(),us=s("td"),al=r("15.6it/s"),sl=p(),se=s("tr"),ms=s("td"),nl=r("NVIDIA RTX A6000"),ol=p(),ds=s("td"),rl=r("11.7it/s"),il=p(),_s=s("td"),ll=r("21.09it/s"),pl=p(),ne=s("tr"),vs=s("td"),fl=r("NVIDIA TITAN RTX"),cl=p(),ys=s("td"),hl=r("12.51it/s"),ul=p(),ws=s("td"),ml=r("18.22it/s"),dl=p(),oe=s("tr"),bs=s("td"),_l=r("A100-SXM4-40GB"),vl=p(),gs=s("td"),yl=r("18.6it/s"),wl=p(),Es=s("td"),bl=r("29.it/s"),gl=p(),re=s("tr"),$s=s("td"),El=r("A100-SXM-80GB"),$l=p(),js=s("td"),jl=r("18.7it/s"),kl=p(),ks=s("td"),Tl=r("29.5it/s"),Pn=p(),Dt=s("p"),Dl=r("To leverage it just make sure you have:"),xn=p(),I=s("ul"),Ts=s("li"),Al=r("PyTorch > 1.12"),Pl=p(),Ds=s("li"),xl=r("Cuda available"),Sl=p(),At=s("li"),Pt=s("a"),ql=r("Installed the xformers library"),Nl=r("."),Sn=p(),u(rt.$$.fragment),this.h()},l(e){const l=tc('[data-svelte="svelte-1phssyn"]',document.head);g=n(l,"META",{name:!0,content:!0}),l.forEach(a),P=f(e),D=n(e,"H1",{class:!0});var it=o(D);le=n(it,"A",{id:!0,class:!0,href:!0});var Cl=o(le);Qt=n(Cl,"SPAN",{});var Fl=o(Qt);m(Se.$$.fragment,Fl),Fl.forEach(a),Cl.forEach(a),Zn=f(it),Jt=n(it,"SPAN",{});var Rl=o(Jt);eo=i(Rl,"Memory and speed"),Rl.forEach(a),it.forEach(a),Ps=f(e),k=n(e,"P",{});var xe=o(k);to=i(xe,"We present some techniques and ideas to optimize \u{1F917} Diffusers "),Zt=n(xe,"EM",{});var Vl=o(Zt);ao=i(Vl,"inference"),Vl.forEach(a),so=i(xe," for memory or speed. As a general rule, we recommend the use of "),qe=n(xe,"A",{href:!0,rel:!0});var Gl=o(qe);no=i(Gl,"xFormers"),Gl.forEach(a),oo=i(xe," for memory efficient attention, please see the recommended "),lt=n(xe,"A",{href:!0});var Ml=o(lt);ro=i(Ml,"installation instructions"),Ml.forEach(a),io=i(xe,"."),xe.forEach(a),xs=f(e),pt=n(e,"P",{});var zl=o(pt);lo=i(zl,"We\u2019ll discuss how the following settings impact performance and memory."),zl.forEach(a),Ss=f(e),pe=n(e,"TABLE",{});var Nn=o(pe);ea=n(Nn,"THEAD",{});var Hl=o(ea);U=n(Hl,"TR",{});var xt=o(U);qs=n(xt,"TH",{}),o(qs).forEach(a),po=f(xt),ta=n(xt,"TH",{});var Ol=o(ta);fo=i(Ol,"Latency"),Ol.forEach(a),co=f(xt),aa=n(xt,"TH",{});var Bl=o(aa);ho=i(Bl,"Speedup"),Bl.forEach(a),xt.forEach(a),Hl.forEach(a),uo=f(Nn),w=n(Nn,"TBODY",{});var E=o(w);C=n(E,"TR",{});var St=o(C);sa=n(St,"TD",{});var Ll=o(sa);mo=i(Ll,"original"),Ll.forEach(a),_o=f(St),na=n(St,"TD",{});var Xl=o(na);vo=i(Xl,"9.50s"),Xl.forEach(a),yo=f(St),oa=n(St,"TD",{});var Yl=o(oa);wo=i(Yl,"x1"),Yl.forEach(a),St.forEach(a),bo=f(E),F=n(E,"TR",{});var qt=o(F);ra=n(qt,"TD",{});var Wl=o(ra);go=i(Wl,"cuDNN auto-tuner"),Wl.forEach(a),Eo=f(qt),ia=n(qt,"TD",{});var Kl=o(ia);$o=i(Kl,"9.37s"),Kl.forEach(a),jo=f(qt),la=n(qt,"TD",{});var Ql=o(la);ko=i(Ql,"x1.01"),Ql.forEach(a),qt.forEach(a),To=f(E),R=n(E,"TR",{});var Nt=o(R);pa=n(Nt,"TD",{});var Jl=o(pa);Do=i(Jl,"autocast (fp16)"),Jl.forEach(a),Ao=f(Nt),fa=n(Nt,"TD",{});var Zl=o(fa);Po=i(Zl,"5.47s"),Zl.forEach(a),xo=f(Nt),ca=n(Nt,"TD",{});var ep=o(ca);So=i(ep,"x1.74"),ep.forEach(a),Nt.forEach(a),qo=f(E),V=n(E,"TR",{});var It=o(V);ha=n(It,"TD",{});var tp=o(ha);No=i(tp,"fp16"),tp.forEach(a),Io=f(It),ua=n(It,"TD",{});var ap=o(ua);Uo=i(ap,"3.61s"),ap.forEach(a),Co=f(It),ma=n(It,"TD",{});var sp=o(ma);Fo=i(sp,"x2.63"),sp.forEach(a),It.forEach(a),Ro=f(E),G=n(E,"TR",{});var Ut=o(G);da=n(Ut,"TD",{});var np=o(da);Vo=i(np,"channels last"),np.forEach(a),Go=f(Ut),_a=n(Ut,"TD",{});var op=o(_a);Mo=i(op,"3.30s"),op.forEach(a),zo=f(Ut),va=n(Ut,"TD",{});var rp=o(va);Ho=i(rp,"x2.88"),rp.forEach(a),Ut.forEach(a),Oo=f(E),M=n(E,"TR",{});var Ct=o(M);ya=n(Ct,"TD",{});var ip=o(ya);Bo=i(ip,"traced UNet"),ip.forEach(a),Lo=f(Ct),wa=n(Ct,"TD",{});var lp=o(wa);Xo=i(lp,"3.21s"),lp.forEach(a),Yo=f(Ct),ba=n(Ct,"TD",{});var pp=o(ba);Wo=i(pp,"x2.96"),pp.forEach(a),Ct.forEach(a),Ko=f(E),z=n(E,"TR",{});var Ft=o(z);ga=n(Ft,"TD",{});var fp=o(ga);Qo=i(fp,"memory efficient attention"),fp.forEach(a),Jo=f(Ft),Ea=n(Ft,"TD",{});var cp=o(Ea);Zo=i(cp,"2.63s"),cp.forEach(a),er=f(Ft),$a=n(Ft,"TD",{});var hp=o($a);tr=i(hp,"x3.61"),hp.forEach(a),Ft.forEach(a),E.forEach(a),Nn.forEach(a),Ns=f(e),ft=n(e,"EM",{});var up=o(ft);ar=i(up,`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),up.forEach(a),Is=f(e),H=n(e,"H2",{class:!0});var In=o(H);fe=n(In,"A",{id:!0,class:!0,href:!0});var mp=o(fe);ja=n(mp,"SPAN",{});var dp=o(ja);m(Ne.$$.fragment,dp),dp.forEach(a),mp.forEach(a),sr=f(In),ka=n(In,"SPAN",{});var _p=o(ka);nr=i(_p,"Enable cuDNN auto-tuner"),_p.forEach(a),In.forEach(a),Us=f(e),Ie=n(e,"P",{});var Il=o(Ie);Ue=n(Il,"A",{href:!0,rel:!0});var vp=o(Ue);or=i(vp,"NVIDIA cuDNN"),vp.forEach(a),rr=i(Il,"\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),Il.forEach(a),Cs=f(e),ce=n(e,"P",{});var Un=o(ce);ir=i(Un,"Since we\u2019re using "),Ta=n(Un,"STRONG",{});var yp=o(Ta);lr=i(yp,"convolutional networks"),yp.forEach(a),pr=i(Un," (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),Un.forEach(a),Fs=f(e),m(Ce.$$.fragment,e),Rs=f(e),O=n(e,"H3",{class:!0});var Cn=o(O);he=n(Cn,"A",{id:!0,class:!0,href:!0});var wp=o(he);Da=n(wp,"SPAN",{});var bp=o(Da);m(Fe.$$.fragment,bp),bp.forEach(a),wp.forEach(a),fr=f(Cn),Aa=n(Cn,"SPAN",{});var gp=o(Aa);cr=i(gp,"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),gp.forEach(a),Cn.forEach(a),Vs=f(e),ue=n(e,"P",{});var Fn=o(ue);hr=i(Fn,"On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Re=n(Fn,"A",{href:!0,rel:!0});var Ep=o(Re);ur=i(Ep,"here"),Ep.forEach(a),mr=i(Fn,". All you need to do is to add this before your inference:"),Fn.forEach(a),Gs=f(e),m(Ve.$$.fragment,e),Ms=f(e),B=n(e,"H2",{class:!0});var Rn=o(B);me=n(Rn,"A",{id:!0,class:!0,href:!0});var $p=o(me);Pa=n($p,"SPAN",{});var jp=o(Pa);m(Ge.$$.fragment,jp),jp.forEach(a),$p.forEach(a),dr=f(Rn),xa=n(Rn,"SPAN",{});var kp=o(xa);_r=i(kp,"Automatic mixed precision (AMP)"),kp.forEach(a),Rn.forEach(a),zs=f(e),x=n(e,"P",{});var Rt=o(x);vr=i(Rt,"If you use a CUDA GPU, you can take advantage of "),Sa=n(Rt,"CODE",{});var Tp=o(Sa);yr=i(Tp,"torch.autocast"),Tp.forEach(a),wr=i(Rt," to perform inference roughly twice as fast at the cost of slightly lower precision. All you need to do is put your inference call inside an "),qa=n(Rt,"CODE",{});var Dp=o(qa);br=i(Dp,"autocast"),Dp.forEach(a),gr=i(Rt," context manager. The following example shows how to do it using Stable Diffusion text-to-image generation as an example:"),Rt.forEach(a),Hs=f(e),m(Me.$$.fragment,e),Os=f(e),de=n(e,"P",{});var Vn=o(de);Er=i(Vn,"Despite the precision loss, in our experience the final image results look the same as the "),Na=n(Vn,"CODE",{});var Ap=o(Na);$r=i(Ap,"float32"),Ap.forEach(a),jr=i(Vn," versions. Feel free to experiment and report back!"),Vn.forEach(a),Bs=f(e),L=n(e,"H2",{class:!0});var Gn=o(L);_e=n(Gn,"A",{id:!0,class:!0,href:!0});var Pp=o(_e);Ia=n(Pp,"SPAN",{});var xp=o(Ia);m(ze.$$.fragment,xp),xp.forEach(a),Pp.forEach(a),kr=f(Gn),Ua=n(Gn,"SPAN",{});var Sp=o(Ua);Tr=i(Sp,"Half precision weights"),Sp.forEach(a),Gn.forEach(a),Ls=f(e),S=n(e,"P",{});var Vt=o(S);Dr=i(Vt,"To save more GPU memory and get even more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Ca=n(Vt,"CODE",{});var qp=o(Ca);Ar=i(qp,"fp16"),qp.forEach(a),Pr=i(Vt,", and telling PyTorch to use the "),Fa=n(Vt,"CODE",{});var Np=o(Fa);xr=i(Np,"float16"),Np.forEach(a),Sr=i(Vt," type when loading them:"),Vt.forEach(a),Xs=f(e),m(He.$$.fragment,e),Ys=f(e),X=n(e,"H2",{class:!0});var Mn=o(X);ve=n(Mn,"A",{id:!0,class:!0,href:!0});var Ip=o(ve);Ra=n(Ip,"SPAN",{});var Up=o(Ra);m(Oe.$$.fragment,Up),Up.forEach(a),Ip.forEach(a),qr=f(Mn),Va=n(Mn,"SPAN",{});var Cp=o(Va);Nr=i(Cp,"Sliced attention for additional memory savings"),Cp.forEach(a),Mn.forEach(a),Ws=f(e),ct=n(e,"P",{});var Fp=o(ct);Ir=i(Fp,"For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),Fp.forEach(a),Ks=f(e),m(ye.$$.fragment,e),Qs=f(e),we=n(e,"P",{});var zn=o(we);Ur=i(zn,"To perform the attention computation sequentially over each head, you only need to invoke "),ht=n(zn,"A",{href:!0});var Rp=o(ht);Cr=i(Rp,"enable_attention_slicing()"),Rp.forEach(a),Fr=i(zn," in your pipeline before inference, like here:"),zn.forEach(a),Js=f(e),m(Be.$$.fragment,e),Zs=f(e),ut=n(e,"P",{});var Vp=o(ut);Rr=i(Vp,"There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),Vp.forEach(a),en=f(e),Y=n(e,"H2",{class:!0});var Hn=o(Y);be=n(Hn,"A",{id:!0,class:!0,href:!0});var Gp=o(be);Ga=n(Gp,"SPAN",{});var Mp=o(Ga);m(Le.$$.fragment,Mp),Mp.forEach(a),Gp.forEach(a),Vr=f(Hn),Ma=n(Hn,"SPAN",{});var zp=o(Ma);Gr=i(zp,"Sliced VAE decode for larger batches"),zp.forEach(a),Hn.forEach(a),tn=f(e),mt=n(e,"P",{});var Hp=o(mt);Mr=i(Hp,"To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),Hp.forEach(a),an=f(e),q=n(e,"P",{});var Gt=o(q);zr=i(Gt,"You likely want to couple this with "),dt=n(Gt,"A",{href:!0});var Op=o(dt);Hr=i(Op,"enable_attention_slicing()"),Op.forEach(a),Or=i(Gt," or "),_t=n(Gt,"A",{href:!0});var Bp=o(_t);Br=i(Bp,"enable_xformers_memory_efficient_attention()"),Bp.forEach(a),Lr=i(Gt," to further minimize memory use."),Gt.forEach(a),sn=f(e),ge=n(e,"P",{});var On=o(ge);Xr=i(On,"To perform the VAE decode one image at a time, invoke "),vt=n(On,"A",{href:!0});var Lp=o(vt);Yr=i(Lp,"enable_vae_slicing()"),Lp.forEach(a),Wr=i(On," in your pipeline before inference. For example:"),On.forEach(a),nn=f(e),m(Xe.$$.fragment,e),on=f(e),yt=n(e,"P",{});var Xp=o(yt);Kr=i(Xp,"You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),Xp.forEach(a),rn=f(e),W=n(e,"H2",{class:!0});var Bn=o(W);Ee=n(Bn,"A",{id:!0,class:!0,href:!0});var Yp=o(Ee);za=n(Yp,"SPAN",{});var Wp=o(za);m(Ye.$$.fragment,Wp),Wp.forEach(a),Yp.forEach(a),Qr=f(Bn),Ha=n(Bn,"SPAN",{});var Kp=o(Ha);Jr=i(Kp,"Offloading to CPU with accelerate for memory savings"),Kp.forEach(a),Bn.forEach(a),ln=f(e),wt=n(e,"P",{});var Qp=o(wt);Zr=i(Qp,"For additional memory savings, you can offload the weights to CPU and only load them to GPU when performing the forward pass."),Qp.forEach(a),pn=f(e),$e=n(e,"P",{});var Ln=o($e);ei=i(Ln,"To perform CPU offloading, all you have to do is invoke "),bt=n(Ln,"A",{href:!0});var Jp=o(bt);ti=i(Jp,"enable_sequential_cpu_offload()"),Jp.forEach(a),ai=i(Ln,":"),Ln.forEach(a),fn=f(e),m(We.$$.fragment,e),cn=f(e),gt=n(e,"P",{});var Zp=o(gt);si=i(Zp,"And you can get the memory consumption to < 3GB."),Zp.forEach(a),hn=f(e),Et=n(e,"P",{});var ef=o(Et);ni=i(ef,"If is also possible to chain it with attention slicing for minimal memory consumption (< 2GB)."),ef.forEach(a),un=f(e),m(Ke.$$.fragment,e),mn=f(e),j=n(e,"P",{});var ie=o(j);Oa=n(ie,"STRONG",{});var tf=o(Oa);oi=i(tf,"Note"),tf.forEach(a),ri=i(ie,": When using "),Ba=n(ie,"CODE",{});var af=o(Ba);ii=i(af,"enable_sequential_cpu_offload()"),af.forEach(a),li=i(ie,", it is important to "),La=n(ie,"STRONG",{});var sf=o(La);pi=i(sf,"not"),sf.forEach(a),fi=i(ie," move the pipeline to CUDA beforehand or else the gain in memory consumption will only be minimal. See "),Qe=n(ie,"A",{href:!0,rel:!0});var nf=o(Qe);ci=i(nf,"this issue"),nf.forEach(a),hi=i(ie," for more information."),ie.forEach(a),dn=f(e),K=n(e,"H2",{class:!0});var Xn=o(K);je=n(Xn,"A",{id:!0,class:!0,href:!0});var of=o(je);Xa=n(of,"SPAN",{});var rf=o(Xa);m(Je.$$.fragment,rf),rf.forEach(a),of.forEach(a),ui=f(Xn),Ya=n(Xn,"SPAN",{});var lf=o(Ya);mi=i(lf,"Using Channels Last memory format"),lf.forEach(a),Xn.forEach(a),_n=f(e),$t=n(e,"P",{});var pf=o($t);di=i(pf,"Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),pf.forEach(a),vn=f(e),jt=n(e,"P",{});var ff=o(jt);_i=i(ff,"For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),ff.forEach(a),yn=f(e),m(Ze.$$.fragment,e),wn=f(e),Q=n(e,"H2",{class:!0});var Yn=o(Q);ke=n(Yn,"A",{id:!0,class:!0,href:!0});var cf=o(ke);Wa=n(cf,"SPAN",{});var hf=o(Wa);m(et.$$.fragment,hf),hf.forEach(a),cf.forEach(a),vi=f(Yn),Ka=n(Yn,"SPAN",{});var uf=o(Ka);yi=i(uf,"Tracing"),uf.forEach(a),Yn.forEach(a),bn=f(e),Te=n(e,"P",{});var Wn=o(Te);wi=i(Wn,"Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),Qa=n(Wn,"CODE",{});var mf=o(Qa);bi=i(mf,"ScriptFunction"),mf.forEach(a),gi=i(Wn," is returned that will be optimized using just-in-time compilation."),Wn.forEach(a),gn=f(e),kt=n(e,"P",{});var df=o(kt);Ei=i(df,"To trace our UNet model, we can use the following:"),df.forEach(a),En=f(e),m(tt.$$.fragment,e),$n=f(e),De=n(e,"P",{});var Kn=o(De);$i=i(Kn,"Then we can replace the "),Ja=n(Kn,"CODE",{});var _f=o(Ja);ji=i(_f,"unet"),_f.forEach(a),ki=i(Kn," attribute of the pipeline with the traced model like the following"),Kn.forEach(a),jn=f(e),m(at.$$.fragment,e),kn=f(e),J=n(e,"H2",{class:!0});var Qn=o(J);Ae=n(Qn,"A",{id:!0,class:!0,href:!0});var vf=o(Ae);Za=n(vf,"SPAN",{});var yf=o(Za);m(st.$$.fragment,yf),yf.forEach(a),vf.forEach(a),Ti=f(Qn),es=n(Qn,"SPAN",{});var wf=o(es);Di=i(wf,"Memory Efficient Attention"),wf.forEach(a),Qn.forEach(a),Tn=f(e),N=n(e,"P",{});var Mt=o(N);Ai=i(Mt,"Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),nt=n(Mt,"A",{href:!0,rel:!0});var bf=o(nt);Pi=i(bf,"code"),bf.forEach(a),xi=i(Mt,", "),ot=n(Mt,"A",{href:!0,rel:!0});var gf=o(ot);Si=i(gf,"paper"),gf.forEach(a),qi=i(Mt,"."),Mt.forEach(a),Dn=f(e),Tt=n(e,"P",{});var Ef=o(Tt);Ni=i(Ef,"Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),Ef.forEach(a),An=f(e),Pe=n(e,"TABLE",{});var Jn=o(Pe);ts=n(Jn,"THEAD",{});var $f=o(ts);Z=n($f,"TR",{});var zt=o(Z);as=n(zt,"TH",{});var jf=o(as);Ii=i(jf,"GPU"),jf.forEach(a),Ui=f(zt),ss=n(zt,"TH",{});var kf=o(ss);Ci=i(kf,"Base Attention FP16"),kf.forEach(a),Fi=f(zt),ns=n(zt,"TH",{});var Tf=o(ns);Ri=i(Tf,"Memory Efficient Attention FP16"),Tf.forEach(a),zt.forEach(a),$f.forEach(a),Vi=f(Jn),b=n(Jn,"TBODY",{});var $=o(b);ee=n($,"TR",{});var Ht=o(ee);os=n(Ht,"TD",{});var Df=o(os);Gi=i(Df,"NVIDIA Tesla T4"),Df.forEach(a),Mi=f(Ht),rs=n(Ht,"TD",{});var Af=o(rs);zi=i(Af,"3.5it/s"),Af.forEach(a),Hi=f(Ht),is=n(Ht,"TD",{});var Pf=o(is);Oi=i(Pf,"5.5it/s"),Pf.forEach(a),Ht.forEach(a),Bi=f($),te=n($,"TR",{});var Ot=o(te);ls=n(Ot,"TD",{});var xf=o(ls);Li=i(xf,"NVIDIA 3060 RTX"),xf.forEach(a),Xi=f(Ot),ps=n(Ot,"TD",{});var Sf=o(ps);Yi=i(Sf,"4.6it/s"),Sf.forEach(a),Wi=f(Ot),fs=n(Ot,"TD",{});var qf=o(fs);Ki=i(qf,"7.8it/s"),qf.forEach(a),Ot.forEach(a),Qi=f($),ae=n($,"TR",{});var Bt=o(ae);cs=n(Bt,"TD",{});var Nf=o(cs);Ji=i(Nf,"NVIDIA A10G"),Nf.forEach(a),Zi=f(Bt),hs=n(Bt,"TD",{});var If=o(hs);el=i(If,"8.88it/s"),If.forEach(a),tl=f(Bt),us=n(Bt,"TD",{});var Uf=o(us);al=i(Uf,"15.6it/s"),Uf.forEach(a),Bt.forEach(a),sl=f($),se=n($,"TR",{});var Lt=o(se);ms=n(Lt,"TD",{});var Cf=o(ms);nl=i(Cf,"NVIDIA RTX A6000"),Cf.forEach(a),ol=f(Lt),ds=n(Lt,"TD",{});var Ff=o(ds);rl=i(Ff,"11.7it/s"),Ff.forEach(a),il=f(Lt),_s=n(Lt,"TD",{});var Rf=o(_s);ll=i(Rf,"21.09it/s"),Rf.forEach(a),Lt.forEach(a),pl=f($),ne=n($,"TR",{});var Xt=o(ne);vs=n(Xt,"TD",{});var Vf=o(vs);fl=i(Vf,"NVIDIA TITAN RTX"),Vf.forEach(a),cl=f(Xt),ys=n(Xt,"TD",{});var Gf=o(ys);hl=i(Gf,"12.51it/s"),Gf.forEach(a),ul=f(Xt),ws=n(Xt,"TD",{});var Mf=o(ws);ml=i(Mf,"18.22it/s"),Mf.forEach(a),Xt.forEach(a),dl=f($),oe=n($,"TR",{});var Yt=o(oe);bs=n(Yt,"TD",{});var zf=o(bs);_l=i(zf,"A100-SXM4-40GB"),zf.forEach(a),vl=f(Yt),gs=n(Yt,"TD",{});var Hf=o(gs);yl=i(Hf,"18.6it/s"),Hf.forEach(a),wl=f(Yt),Es=n(Yt,"TD",{});var Of=o(Es);bl=i(Of,"29.it/s"),Of.forEach(a),Yt.forEach(a),gl=f($),re=n($,"TR",{});var Wt=o(re);$s=n(Wt,"TD",{});var Bf=o($s);El=i(Bf,"A100-SXM-80GB"),Bf.forEach(a),$l=f(Wt),js=n(Wt,"TD",{});var Lf=o(js);jl=i(Lf,"18.7it/s"),Lf.forEach(a),kl=f(Wt),ks=n(Wt,"TD",{});var Xf=o(ks);Tl=i(Xf,"29.5it/s"),Xf.forEach(a),Wt.forEach(a),$.forEach(a),Jn.forEach(a),Pn=f(e),Dt=n(e,"P",{});var Yf=o(Dt);Dl=i(Yf,"To leverage it just make sure you have:"),Yf.forEach(a),xn=f(e),I=n(e,"UL",{});var Kt=o(I);Ts=n(Kt,"LI",{});var Wf=o(Ts);Al=i(Wf,"PyTorch > 1.12"),Wf.forEach(a),Pl=f(Kt),Ds=n(Kt,"LI",{});var Kf=o(Ds);xl=i(Kf,"Cuda available"),Kf.forEach(a),Sl=f(Kt),At=n(Kt,"LI",{});var Ul=o(At);Pt=n(Ul,"A",{href:!0});var Qf=o(Pt);ql=i(Qf,"Installed the xformers library"),Qf.forEach(a),Nl=i(Ul,"."),Ul.forEach(a),Kt.forEach(a),Sn=f(e),m(rt.$$.fragment,e),this.h()},h(){h(g,"name","hf:doc:metadata"),h(g,"content",JSON.stringify(rc)),h(le,"id","memory-and-speed"),h(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(le,"href","#memory-and-speed"),h(D,"class","relative group"),h(qe,"href","https://github.com/facebookresearch/xformers"),h(qe,"rel","nofollow"),h(lt,"href","xformers"),h(fe,"id","enable-cudnn-autotuner"),h(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(fe,"href","#enable-cudnn-autotuner"),h(H,"class","relative group"),h(Ue,"href","https://developer.nvidia.com/cudnn"),h(Ue,"rel","nofollow"),h(he,"id","use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(he,"href","#use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(O,"class","relative group"),h(Re,"href","https://huggingface.co/docs/transformers/v4.18.0/en/performance#tf32"),h(Re,"rel","nofollow"),h(me,"id","automatic-mixed-precision-amp"),h(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(me,"href","#automatic-mixed-precision-amp"),h(B,"class","relative group"),h(_e,"id","half-precision-weights"),h(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(_e,"href","#half-precision-weights"),h(L,"class","relative group"),h(ve,"id","sliced-attention-for-additional-memory-savings"),h(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ve,"href","#sliced-attention-for-additional-memory-savings"),h(X,"class","relative group"),h(ht,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_attention_slicing"),h(be,"id","sliced-vae-decode-for-larger-batches"),h(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(be,"href","#sliced-vae-decode-for-larger-batches"),h(Y,"class","relative group"),h(dt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_attention_slicing"),h(_t,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_xformers_memory_efficient_attention"),h(vt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_vae_slicing"),h(Ee,"id","offloading-to-cpu-with-accelerate-for-memory-savings"),h(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ee,"href","#offloading-to-cpu-with-accelerate-for-memory-savings"),h(W,"class","relative group"),h(bt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_sequential_cpu_offload"),h(Qe,"href","https://github.com/huggingface/diffusers/issues/1934"),h(Qe,"rel","nofollow"),h(je,"id","using-channels-last-memory-format"),h(je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(je,"href","#using-channels-last-memory-format"),h(K,"class","relative group"),h(ke,"id","tracing"),h(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ke,"href","#tracing"),h(Q,"class","relative group"),h(Ae,"id","memory-efficient-attention"),h(Ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ae,"href","#memory-efficient-attention"),h(J,"class","relative group"),h(nt,"href","https://github.com/HazyResearch/flash-attention"),h(nt,"rel","nofollow"),h(ot,"href","https://arxiv.org/pdf/2205.14135.pdf"),h(ot,"rel","nofollow"),h(Pt,"href","xformers")},m(e,l){t(document.head,g),c(e,P,l),c(e,D,l),t(D,le),t(le,Qt),d(Se,Qt,null),t(D,Zn),t(D,Jt),t(Jt,eo),c(e,Ps,l),c(e,k,l),t(k,to),t(k,Zt),t(Zt,ao),t(k,so),t(k,qe),t(qe,no),t(k,oo),t(k,lt),t(lt,ro),t(k,io),c(e,xs,l),c(e,pt,l),t(pt,lo),c(e,Ss,l),c(e,pe,l),t(pe,ea),t(ea,U),t(U,qs),t(U,po),t(U,ta),t(ta,fo),t(U,co),t(U,aa),t(aa,ho),t(pe,uo),t(pe,w),t(w,C),t(C,sa),t(sa,mo),t(C,_o),t(C,na),t(na,vo),t(C,yo),t(C,oa),t(oa,wo),t(w,bo),t(w,F),t(F,ra),t(ra,go),t(F,Eo),t(F,ia),t(ia,$o),t(F,jo),t(F,la),t(la,ko),t(w,To),t(w,R),t(R,pa),t(pa,Do),t(R,Ao),t(R,fa),t(fa,Po),t(R,xo),t(R,ca),t(ca,So),t(w,qo),t(w,V),t(V,ha),t(ha,No),t(V,Io),t(V,ua),t(ua,Uo),t(V,Co),t(V,ma),t(ma,Fo),t(w,Ro),t(w,G),t(G,da),t(da,Vo),t(G,Go),t(G,_a),t(_a,Mo),t(G,zo),t(G,va),t(va,Ho),t(w,Oo),t(w,M),t(M,ya),t(ya,Bo),t(M,Lo),t(M,wa),t(wa,Xo),t(M,Yo),t(M,ba),t(ba,Wo),t(w,Ko),t(w,z),t(z,ga),t(ga,Qo),t(z,Jo),t(z,Ea),t(Ea,Zo),t(z,er),t(z,$a),t($a,tr),c(e,Ns,l),c(e,ft,l),t(ft,ar),c(e,Is,l),c(e,H,l),t(H,fe),t(fe,ja),d(Ne,ja,null),t(H,sr),t(H,ka),t(ka,nr),c(e,Us,l),c(e,Ie,l),t(Ie,Ue),t(Ue,or),t(Ie,rr),c(e,Cs,l),c(e,ce,l),t(ce,ir),t(ce,Ta),t(Ta,lr),t(ce,pr),c(e,Fs,l),d(Ce,e,l),c(e,Rs,l),c(e,O,l),t(O,he),t(he,Da),d(Fe,Da,null),t(O,fr),t(O,Aa),t(Aa,cr),c(e,Vs,l),c(e,ue,l),t(ue,hr),t(ue,Re),t(Re,ur),t(ue,mr),c(e,Gs,l),d(Ve,e,l),c(e,Ms,l),c(e,B,l),t(B,me),t(me,Pa),d(Ge,Pa,null),t(B,dr),t(B,xa),t(xa,_r),c(e,zs,l),c(e,x,l),t(x,vr),t(x,Sa),t(Sa,yr),t(x,wr),t(x,qa),t(qa,br),t(x,gr),c(e,Hs,l),d(Me,e,l),c(e,Os,l),c(e,de,l),t(de,Er),t(de,Na),t(Na,$r),t(de,jr),c(e,Bs,l),c(e,L,l),t(L,_e),t(_e,Ia),d(ze,Ia,null),t(L,kr),t(L,Ua),t(Ua,Tr),c(e,Ls,l),c(e,S,l),t(S,Dr),t(S,Ca),t(Ca,Ar),t(S,Pr),t(S,Fa),t(Fa,xr),t(S,Sr),c(e,Xs,l),d(He,e,l),c(e,Ys,l),c(e,X,l),t(X,ve),t(ve,Ra),d(Oe,Ra,null),t(X,qr),t(X,Va),t(Va,Nr),c(e,Ws,l),c(e,ct,l),t(ct,Ir),c(e,Ks,l),d(ye,e,l),c(e,Qs,l),c(e,we,l),t(we,Ur),t(we,ht),t(ht,Cr),t(we,Fr),c(e,Js,l),d(Be,e,l),c(e,Zs,l),c(e,ut,l),t(ut,Rr),c(e,en,l),c(e,Y,l),t(Y,be),t(be,Ga),d(Le,Ga,null),t(Y,Vr),t(Y,Ma),t(Ma,Gr),c(e,tn,l),c(e,mt,l),t(mt,Mr),c(e,an,l),c(e,q,l),t(q,zr),t(q,dt),t(dt,Hr),t(q,Or),t(q,_t),t(_t,Br),t(q,Lr),c(e,sn,l),c(e,ge,l),t(ge,Xr),t(ge,vt),t(vt,Yr),t(ge,Wr),c(e,nn,l),d(Xe,e,l),c(e,on,l),c(e,yt,l),t(yt,Kr),c(e,rn,l),c(e,W,l),t(W,Ee),t(Ee,za),d(Ye,za,null),t(W,Qr),t(W,Ha),t(Ha,Jr),c(e,ln,l),c(e,wt,l),t(wt,Zr),c(e,pn,l),c(e,$e,l),t($e,ei),t($e,bt),t(bt,ti),t($e,ai),c(e,fn,l),d(We,e,l),c(e,cn,l),c(e,gt,l),t(gt,si),c(e,hn,l),c(e,Et,l),t(Et,ni),c(e,un,l),d(Ke,e,l),c(e,mn,l),c(e,j,l),t(j,Oa),t(Oa,oi),t(j,ri),t(j,Ba),t(Ba,ii),t(j,li),t(j,La),t(La,pi),t(j,fi),t(j,Qe),t(Qe,ci),t(j,hi),c(e,dn,l),c(e,K,l),t(K,je),t(je,Xa),d(Je,Xa,null),t(K,ui),t(K,Ya),t(Ya,mi),c(e,_n,l),c(e,$t,l),t($t,di),c(e,vn,l),c(e,jt,l),t(jt,_i),c(e,yn,l),d(Ze,e,l),c(e,wn,l),c(e,Q,l),t(Q,ke),t(ke,Wa),d(et,Wa,null),t(Q,vi),t(Q,Ka),t(Ka,yi),c(e,bn,l),c(e,Te,l),t(Te,wi),t(Te,Qa),t(Qa,bi),t(Te,gi),c(e,gn,l),c(e,kt,l),t(kt,Ei),c(e,En,l),d(tt,e,l),c(e,$n,l),c(e,De,l),t(De,$i),t(De,Ja),t(Ja,ji),t(De,ki),c(e,jn,l),d(at,e,l),c(e,kn,l),c(e,J,l),t(J,Ae),t(Ae,Za),d(st,Za,null),t(J,Ti),t(J,es),t(es,Di),c(e,Tn,l),c(e,N,l),t(N,Ai),t(N,nt),t(nt,Pi),t(N,xi),t(N,ot),t(ot,Si),t(N,qi),c(e,Dn,l),c(e,Tt,l),t(Tt,Ni),c(e,An,l),c(e,Pe,l),t(Pe,ts),t(ts,Z),t(Z,as),t(as,Ii),t(Z,Ui),t(Z,ss),t(ss,Ci),t(Z,Fi),t(Z,ns),t(ns,Ri),t(Pe,Vi),t(Pe,b),t(b,ee),t(ee,os),t(os,Gi),t(ee,Mi),t(ee,rs),t(rs,zi),t(ee,Hi),t(ee,is),t(is,Oi),t(b,Bi),t(b,te),t(te,ls),t(ls,Li),t(te,Xi),t(te,ps),t(ps,Yi),t(te,Wi),t(te,fs),t(fs,Ki),t(b,Qi),t(b,ae),t(ae,cs),t(cs,Ji),t(ae,Zi),t(ae,hs),t(hs,el),t(ae,tl),t(ae,us),t(us,al),t(b,sl),t(b,se),t(se,ms),t(ms,nl),t(se,ol),t(se,ds),t(ds,rl),t(se,il),t(se,_s),t(_s,ll),t(b,pl),t(b,ne),t(ne,vs),t(vs,fl),t(ne,cl),t(ne,ys),t(ys,hl),t(ne,ul),t(ne,ws),t(ws,ml),t(b,dl),t(b,oe),t(oe,bs),t(bs,_l),t(oe,vl),t(oe,gs),t(gs,yl),t(oe,wl),t(oe,Es),t(Es,bl),t(b,gl),t(b,re),t(re,$s),t($s,El),t(re,$l),t(re,js),t(js,jl),t(re,kl),t(re,ks),t(ks,Tl),c(e,Pn,l),c(e,Dt,l),t(Dt,Dl),c(e,xn,l),c(e,I,l),t(I,Ts),t(Ts,Al),t(I,Pl),t(I,Ds),t(Ds,xl),t(I,Sl),t(I,At),t(At,Pt),t(Pt,ql),t(At,Nl),c(e,Sn,l),d(rt,e,l),qn=!0},p(e,[l]){const it={};l&2&&(it.$$scope={dirty:l,ctx:e}),ye.$set(it)},i(e){qn||(_(Se.$$.fragment,e),_(Ne.$$.fragment,e),_(Ce.$$.fragment,e),_(Fe.$$.fragment,e),_(Ve.$$.fragment,e),_(Ge.$$.fragment,e),_(Me.$$.fragment,e),_(ze.$$.fragment,e),_(He.$$.fragment,e),_(Oe.$$.fragment,e),_(ye.$$.fragment,e),_(Be.$$.fragment,e),_(Le.$$.fragment,e),_(Xe.$$.fragment,e),_(Ye.$$.fragment,e),_(We.$$.fragment,e),_(Ke.$$.fragment,e),_(Je.$$.fragment,e),_(Ze.$$.fragment,e),_(et.$$.fragment,e),_(tt.$$.fragment,e),_(at.$$.fragment,e),_(st.$$.fragment,e),_(rt.$$.fragment,e),qn=!0)},o(e){v(Se.$$.fragment,e),v(Ne.$$.fragment,e),v(Ce.$$.fragment,e),v(Fe.$$.fragment,e),v(Ve.$$.fragment,e),v(Ge.$$.fragment,e),v(Me.$$.fragment,e),v(ze.$$.fragment,e),v(He.$$.fragment,e),v(Oe.$$.fragment,e),v(ye.$$.fragment,e),v(Be.$$.fragment,e),v(Le.$$.fragment,e),v(Xe.$$.fragment,e),v(Ye.$$.fragment,e),v(We.$$.fragment,e),v(Ke.$$.fragment,e),v(Je.$$.fragment,e),v(Ze.$$.fragment,e),v(et.$$.fragment,e),v(tt.$$.fragment,e),v(at.$$.fragment,e),v(st.$$.fragment,e),v(rt.$$.fragment,e),qn=!1},d(e){a(g),e&&a(P),e&&a(D),y(Se),e&&a(Ps),e&&a(k),e&&a(xs),e&&a(pt),e&&a(Ss),e&&a(pe),e&&a(Ns),e&&a(ft),e&&a(Is),e&&a(H),y(Ne),e&&a(Us),e&&a(Ie),e&&a(Cs),e&&a(ce),e&&a(Fs),y(Ce,e),e&&a(Rs),e&&a(O),y(Fe),e&&a(Vs),e&&a(ue),e&&a(Gs),y(Ve,e),e&&a(Ms),e&&a(B),y(Ge),e&&a(zs),e&&a(x),e&&a(Hs),y(Me,e),e&&a(Os),e&&a(de),e&&a(Bs),e&&a(L),y(ze),e&&a(Ls),e&&a(S),e&&a(Xs),y(He,e),e&&a(Ys),e&&a(X),y(Oe),e&&a(Ws),e&&a(ct),e&&a(Ks),y(ye,e),e&&a(Qs),e&&a(we),e&&a(Js),y(Be,e),e&&a(Zs),e&&a(ut),e&&a(en),e&&a(Y),y(Le),e&&a(tn),e&&a(mt),e&&a(an),e&&a(q),e&&a(sn),e&&a(ge),e&&a(nn),y(Xe,e),e&&a(on),e&&a(yt),e&&a(rn),e&&a(W),y(Ye),e&&a(ln),e&&a(wt),e&&a(pn),e&&a($e),e&&a(fn),y(We,e),e&&a(cn),e&&a(gt),e&&a(hn),e&&a(Et),e&&a(un),y(Ke,e),e&&a(mn),e&&a(j),e&&a(dn),e&&a(K),y(Je),e&&a(_n),e&&a($t),e&&a(vn),e&&a(jt),e&&a(yn),y(Ze,e),e&&a(wn),e&&a(Q),y(et),e&&a(bn),e&&a(Te),e&&a(gn),e&&a(kt),e&&a(En),y(tt,e),e&&a($n),e&&a(De),e&&a(jn),y(at,e),e&&a(kn),e&&a(J),y(st),e&&a(Tn),e&&a(N),e&&a(Dn),e&&a(Tt),e&&a(An),e&&a(Pe),e&&a(Pn),e&&a(Dt),e&&a(xn),e&&a(I),e&&a(Sn),y(rt,e)}}}const rc={local:"memory-and-speed",sections:[{local:"enable-cudnn-autotuner",sections:[{local:"use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices",title:"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"}],title:"Enable cuDNN auto-tuner"},{local:"automatic-mixed-precision-amp",title:"Automatic mixed precision (AMP)"},{local:"half-precision-weights",title:"Half precision weights"},{local:"sliced-attention-for-additional-memory-savings",title:"Sliced attention for additional memory savings"},{local:"sliced-vae-decode-for-larger-batches",title:"Sliced VAE decode for larger batches"},{local:"offloading-to-cpu-with-accelerate-for-memory-savings",title:"Offloading to CPU with accelerate for memory savings"},{local:"using-channels-last-memory-format",title:"Using Channels Last memory format"},{local:"tracing",title:"Tracing"},{local:"memory-efficient-attention",title:"Memory Efficient Attention"}],title:"Memory and speed"};function ic(As){return ac(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class hc extends Jf{constructor(g){super();Zf(this,g,ic,oc,ec,{})}}export{hc as default,rc as metadata};
